<?php

class Def {
	
	static $fields = null,
		$subj = null,
		$doctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">',
		$meta = '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />',
		$style = '
<link rel="stylesheet" type="text/css" href="site.css" />
<link rel="stylesheet" type="text/css" href="classes.css" />
<link rel="stylesheet" type="text/css" href="tabsort1.css" />
<link rel="stylesheet" type="text/css" href="ie_free.css" />
',
		$script = '
<script type="text/javascript" src="tabtools1.js"></script>
<script type="text/javascript" src="tabsort1.js"></script>
',
		$def_subj = 'user',
		$env = array()
		;
	
	function init()
	{
		if (!self::$fields) self::$fields = get_php('model_fields.php');
		if (!self::$subj) self::$subj = get_php('model_subj.php');
		
		$env = array(
			'root' => 'DOCUMENT_ROOT', 
			'uri' => 'REQUEST_URI', 
			'script' => 'SCRIPT_NAME', 
			'path' => 'SCRIPT_FILENAME'
		);
		foreach($env as $key => $value) {
			$env[$key] = (isset($_ENV[$value])) ? $_ENV[$value] : $_SERVER[$value];
		}
		self::$env = $env;
	}
	
	function get_view($subj)
	{
		$ret = array(
			'where' => array(),
			'full_key' => false
		);
		
		$fields = self::$fields;
		if (!isset($fields[$subj])) return $ret;
		
		$curr_fields = $fields[$subj];
		$full_key = '';
		foreach($curr_fields as $key => $props) {
			$pk = $props['key'];
			if (isset($_GET[$key])) {
				$ret['where'][$key] = $_GET[$key];
				if ($pk == 1) $full_key .= $_GET[$key] . ' ';
			}
			else if ($pk == 1) $full_key = false;
		}
		
		$ret['full_key'] = $full_key;
		return $ret;
	}
	
	function file_list(&$files)
	{
		
		$fileList = array();
		$total_count = count($files);
		$total_size = 0;

		foreach($files as $key => $file) {
			$size = filesize($file);
			$name = str_replace(Def::$env['root'], '', $file);
			$fileList[$name] = $name . ', ' . round($size / 1024, 2) . ' K';
			$total_size += $size;
		}
		
		$total_size = round($total_size / 1024, 2) . ' K';
		return array('fileList' => $fileList, 'total_count' => $total_count, 'total_size' => $total_size);
	}
	
	function php_files() 
	{
		
		$files = get_included_files();
		return Def::file_list($files);
	}
	
	function fw_files() 
	{
		$arr = Def::get_dir_files(SITE);
		$arr = array_merge($arr, Def::get_dir_files(LIB));
		return Def::file_list($arr);
	}
	
	function get_dir_files($dir)
	{
		$arr = array();
		$handled = opendir($dir);
		while (false !== ($file = readdir($handled))) { 
			if ($file != "." && $file != "..") $arr[] = $dir . '/' . $file;
		}
		closedir($handled);
		return $arr;
	}
	
}